
#include <stdbool.h>
#include <stdint.h>
#include <stdio.h>
#include "nrf_libuarte_async.h"
#include "nrf_drv_clock.h"
#include <bsp.h>

#include "nrf_log.h"
#include "nrf_log_ctrl.h"
#include "nrf_log_default_backends.h"

#include "nrf_queue.h"
#include "nrf_delay.h"



#define pin_rx0 26//NRF_GPIO_PIN_MAP(0, 26)
#define pin_tx0 27//NRF_GPIO_PIN_MAP(0, 27)
#define pin_rx1 NRF_GPIO_PIN_MAP(1, 13)
#define pin_tx1 NRF_GPIO_PIN_MAP(1, 14)

NRF_LIBUARTE_ASYNC_DEFINE(uarte0, 0, 0, 0, NRF_LIBUARTE_PERIPHERAL_NOT_USED, 255, 3);
NRF_LIBUARTE_ASYNC_DEFINE(uarte1, 1, 2, 2, NRF_LIBUARTE_PERIPHERAL_NOT_USED, 255, 3);

static uint8_t text[] = "UART example started.\r\n Loopback:\r\n";
static uint8_t text_size = sizeof(text);
static uint8_t text1[] = "UART111111 example started.\r\n";
static uint8_t text_size1 = sizeof(text1);
static volatile bool m_loopback_phase;
//****************************************************************************************
ret_code_t GSM_send(void  * , uint8_t );
unsigned char sendCommand_resp(char* ,unsigned int , char*  , int );
uint8_t gsm_sms(void);

//****************************************************************************************
 char arraow = '>';
 uint8_t mqtt_st=0;
 uint8_t retry=0;

uint8_t uart0_array[256] ={0};
uint8_t uart1_array[256]={0};

   typedef struct
{
  unsigned char RxBuf[256];
  unsigned int RxBuf_Len;
  unsigned char TxBuf[256];
  unsigned int TxBuf_Len;

}uart_d;
  uart_d gsm_d;
//********************************************************************************************

typedef struct {
    uint8_t * p_data;
    uint32_t length;
} buffer_t;

NRF_QUEUE_DEF(buffer_t, m_buf_queue, 10, NRF_QUEUE_MODE_NO_OVERFLOW);



void uart0_event_handler(void * context, nrf_libuarte_async_evt_t * p_evt)
{
    nrf_libuarte_async_t * p_libuarte = (nrf_libuarte_async_t *)context;
    ret_code_t ret;

    switch (p_evt->type)
    {
        case NRF_LIBUARTE_ASYNC_EVT_ERROR:
            //bsp_board_led_invert(0);
            break;
        case NRF_LIBUARTE_ASYNC_EVT_RX_DATA:
            //memset(uart0_array,0,sizeof(uart0_array));
            //memcpy(uart0_array,p_evt->data.rxtx.p_data,p_evt->data.rxtx.length);

            strcat(uart0_array,p_evt->data.rxtx.p_data);
            break;
        case NRF_LIBUARTE_ASYNC_EVT_TX_DONE:
            
            break;
        default:
            break;
    }
}

void uart1_event_handler(void * context, nrf_libuarte_async_evt_t * p_evt)
{
    nrf_libuarte_async_t * p_libuarte = (nrf_libuarte_async_t *)context;
    ret_code_t ret;

    switch (p_evt->type)
    {
        case NRF_LIBUARTE_ASYNC_EVT_ERROR:
            //bsp_board_led_invert(0);
            break;
        case NRF_LIBUARTE_ASYNC_EVT_RX_DATA:
            //memset(uart1_array,0,sizeof(uart1_array));
            //memcpy(uart1_array,p_evt->data.rxtx.p_data,p_evt->data.rxtx.length);

            strcat(uart1_array,p_evt->data.rxtx.p_data);

            break;
        case NRF_LIBUARTE_ASYNC_EVT_TX_DONE:
            break;
        default:
            break;
    }
}

/**
 * @brief Function for main application entry.
 */
int main(void)
{

//******************************************************************
    ret_code_t err_code = NRF_LOG_INIT(app_timer_cnt_get);
    APP_ERROR_CHECK(err_code);

    NRF_LOG_DEFAULT_BACKENDS_INIT();

      NRF_LOG_INFO("PROGRAM STARTED");

    int32_t reset_reason = NRF_POWER->RESETREAS;
    NRF_LOG_INFO("Reset reason = 0x%08x.\n", reset_reason);
    NRF_POWER->RESETREAS = NRF_POWER->RESETREAS;

//******************************************************************
   
    ret_code_t ret = nrf_drv_clock_init();
    APP_ERROR_CHECK(ret);
  
    nrf_drv_clock_lfclk_request(NULL);

    nrf_libuarte_async_config_t nrf_libuarte0_async_config = {
            .tx_pin     = pin_tx0,//TX_PIN_NUMBER,
            .rx_pin     = pin_rx0,//RX_PIN_NUMBER,
            .baudrate   = NRF_UARTE_BAUDRATE_115200,
            .parity     = NRF_UARTE_PARITY_EXCLUDED,
            .hwfc       = NRF_UARTE_HWFC_DISABLED,
            .timeout_us = 100,
            .int_prio   = APP_IRQ_PRIORITY_LOW
    };

    nrf_libuarte_async_config_t nrf_libuarte1_async_config = {
            .tx_pin     = pin_tx1,//TX_PIN_NUMBER,
            .rx_pin     = pin_rx1,//RX_PIN_NUMBER,
            .baudrate   = NRF_UARTE_BAUDRATE_115200,
            .parity     = NRF_UARTE_PARITY_EXCLUDED,
            .hwfc       = NRF_UARTE_HWFC_DISABLED,
            .timeout_us = 100,
            .int_prio   = APP_IRQ_PRIORITY_LOW
    };

    err_code = nrf_libuarte_async_init(&uarte0, &nrf_libuarte0_async_config, uart0_event_handler, (void *)&uarte0);
    NRF_LOG_INFO("err_code: %u",err_code);
    APP_ERROR_CHECK(err_code);
    
    err_code = nrf_libuarte_async_init(&uarte1, &nrf_libuarte1_async_config, uart1_event_handler, (void *)&uarte1);
    APP_ERROR_CHECK(err_code);

    nrf_libuarte_async_enable(&uarte0);
    nrf_libuarte_async_enable(&uarte1);

    err_code = nrf_libuarte_async_tx(&uarte0, text, text_size);
    APP_ERROR_CHECK(err_code);

    err_code = nrf_libuarte_async_tx(&uarte1, text1,text_size1);
    APP_ERROR_CHECK(err_code);

    nrf_delay_ms(500);

    uint8_t sss=0;
     sss = gsm_sms();

    while (true)
    {
        NRF_LOG_FLUSH();
    }
}

ret_code_t GSM_send(void  * p_dataa, uint8_t len)//timeout in milliseconds
{
  //NRF_LOG_INFO("In GSM_send -----");
  //NRF_LOG_INFO("pdata: %s",p_dataa);
  //NRF_LOG_INFO("len: %u",len);
  return nrf_libuarte_async_tx(&uarte0, p_dataa, len);
}
unsigned char sendCommand_resp(char* cmd_buf,unsigned int cmd_buf_len, char* resbuf, int timeout)
{
  unsigned char status=0;
  
  memset(&gsm_d, 0x00, sizeof(gsm_d));
  memset(&uart0_array, 0x00, sizeof(uart0_array));

  memcpy(gsm_d.TxBuf,cmd_buf,cmd_buf_len);
  gsm_d.TxBuf_Len=cmd_buf_len;

  APP_ERROR_CHECK(GSM_send(gsm_d.TxBuf,gsm_d.TxBuf_Len));

  while(timeout--)
  {
    char * tt=0;
    char * tt1=0;
    if(strlen(uart0_array)!=0)
    {
    memcpy(gsm_d.RxBuf,uart0_array,strlen(uart0_array));
    NRF_LOG_INFO("gsm_d.RxBuf: %s",gsm_d.RxBuf);
    NRF_LOG_INFO("rx_buff: %s",uart0_array);
    }

    //tt = strstr((const char*)uart0_array,resbuf);
    //tt1 = strstr((const char*)uart0_array,"ERR");
    tt = strstr((const char*)gsm_d.RxBuf,resbuf);
    tt1 = strstr((const char*)gsm_d.RxBuf,"ERR");
    if(tt1 !=0)
    { 
      //status = 0;
      //return status;
    }
    if(tt != 0)
    {
      //memset(rx_buff,0,sizeof(rx_buff));
      //rx_len=0;
      status = 1;
      return status;
    }
    nrf_delay_ms(1);
  }
  return status;
}//sendCommand_resp

//******************************************************************************************
uint8_t gsm_sms(void)
{
  uint8_t status = 0;
  mqtt_st=0;
  retry=0;
  uint8_t cntrl = 0;
  char l_buf[128];
      
  strt:

  mqtt_st=0;
  ATE0:
  if((!sendCommand_resp("ATE0\r\n",strlen("ATE0\r\n"),"OK",5000))&&(retry<10))
    {
      mqtt_st++;
      if(mqtt_st<3)
      { 
        goto ATE0;
      }
      status = 0;
      //return status;
    }

  mqtt_st=0;
  AT:
  if((!sendCommand_resp("AT\r\n",strlen("AT\r\n"),"OK",5000))&&(retry<10))
    {
      mqtt_st++;
      if(mqtt_st<3)
      { 
        goto AT;
      }
      cntrl = 1;
      retry++;
      goto strt;
    }


    mqtt_st=0;
  CMGF:
  if((!sendCommand_resp("AT+CMGF=1\r\n",strlen("AT+CMGF=1\r\n"),"OK",5000))&&(retry<10))
    {
      mqtt_st++;
      if(mqtt_st<3)
      { 
        goto CMGF;
      }
      cntrl = 1;
      retry++;
      goto strt;
    }

    mqtt_st=0;
  CMGS:
  if((!sendCommand_resp("AT+CMGS=\"9652490222\"\r\n",strlen("AT+CMGS=\"9652490222\"\r\n"),&arraow,5000))&&(retry<10))
  {
      mqtt_st++;
      if(mqtt_st<3)
      { 
        goto CMGS;
      }
      cntrl = 1;
      retry++;
      goto strt;
  }

    mqtt_st=0;
  D1:

      memset(l_buf,0,sizeof(l_buf));
      sprintf(l_buf,"DISC");      
     l_buf[strlen(l_buf)] = 0x1a;
  if((!sendCommand_resp(l_buf,strlen(l_buf),"OK",5000))&&(retry<10))
    {
      mqtt_st++;
      if(mqtt_st<3)
      { 
        goto D1;
      }
      cntrl = 1;
      retry++;
      goto strt;
    }


   
if(retry >= 10)
{
  return 0;
}
return 1;
    
}//gsm_sms


/** @} */
